;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;		Program	Config
;01.Code protection selection:	Not Protect 
;02.LV reset mode: 				LVR disable
;03.Fast Clock source selection:Fast Crystal 
;04.WDT reset enable			Disable WDT Reset  
;05.EV option(5) 				INT_CLK
;06 IRC Frequency select        0
;----------------------------------
;File Note:
;Name TM57ML40_buzzer.asm 
;check sum:1A23H 
;Date 2010/11/9
;----------------------------------
;Program Note:
;FBZ = (fOSC/2) / (Instruction Cycle Divider) / (BUZ_PROD +1)
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

#include "TM57ML40_en.inc"
	
		org		000h	  
		goto	start
;----------------------------------- 
		org		10h	 
start: 								;pwm Initialization
		movlw	11111111b
		movwr	PDE
		
        movlw	01001001b
        movwr	BUZ
									;BUZ_PSC bit(7~6),BUZZER Clock Prescaler
									;00: BUZZER clock is Instruction Cycle divided by 4
									;01: BUZZER clock is Instruction Cycle divided by 8
									;10: BUZZER clock is Instruction Cycle divided by 16
									;11: BUZZER clock is Instruction Cycle divided by 32
									
									;bit(5~0)BUZ_PROD BUZZER Period Data.   				  
		movlw	00010000b
		movwr	WKTPSC   			;bit4 enable BUZZER output to PD1 pin
		
		movlw	00100000b
		movwr	TM1_PWM0_PSC  		;bit5  enable BUZZER timer counting
        
 
main:  
        nop
		nop 

		goto	main  