;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;		Program	Config
;01.Code protection selection:	Not Protect 
;02.LV reset mode: 				LVR disable
;03.Fast Clock source selection:Fast Crystal 
;04.WDT reset enable			Disable WDT Reset  
;05.EV option(5) 				INT_CLK
;06 IRC Frequency select        0
;----------------------------------
;File Note:
;Name TM57ML40_cap.asm 
;check sum:0DD2H 
;Date:2010/11/9
;----------------------------------
;Program Note:
;
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
#include "TM57ML40_en.inc"
			
		org		00h	  
		goto	start
		org		02h
		goto	timer1_int
		org		03h
		goto	timer0_int	
		org		07h
		goto	xintb_int 			;capж

 
		org		10h	 
start: 								;pwm Initialization 
		movlw   00000000B
		movwf 	INTF1
		
		movlw   00000000B
		movwf	INTE1
		
		movlw   00100000b
		movwr	CLKCTRL	 			;Auto Save W register and STATUS register when interrupt, 

		movlw	11111111b
		movwr	PAE	              	;is output
	
		movlw	11111111b
		movwf	PBD	              	;PB1 is input
			
		movlw	11111101b
		movwr	PBE	              	;PB1 is input
		
		movlw	11111101b
		movwr	PB_PULL	            ;is output
        
        movlw	11000000b
        movwr	OPTION     			;bit7=1	Low level capture
        							;bit6 Timer0 works in CAPTURE Mode; 
        
        movlw	00000011b
        movwr	TM1_PWM0_PSC 		;bit1 =1 Timer1 working in capture mode,
                                    ;bit0 Timer1 Clock Select,1: Fosc,0: Instruction cycle (Fosc/2)
                                    
		bsf		INTE1,TM1IE			;Enable timer1 int  
        bsf		INTE1,TM0IE

		movlw	00000000b
        movwf	TM1L 
        movwf	TM1H 
        movwf	TIMER0

 		bsf		INTE2,XINT3E		;XINT3 (PB1) falling Interrupt Enable.
        

main:  
       	nop
		nop 

		goto	main  
;----------------------------------- 
;			interrput
;-----------------------------------
xintb_int: 
		bcf		INTF2,XINT3F
        goto	int_end	 
timer0_int: 
        bcf		INTF1,TM0I 
        goto	int_end	
timer1_int:
		bcf		INTF1,TM1I 
int_end:
		reti
				                
        end