;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;		Program	Config
;01.Code protection selection:	Not Protect 
;02.LV reset mode: 				LVR disable
;03.Fast Clock source selection:Fast Crystal 
;04.WDT reset enable			Disable WDT Reset  
;05.EV option(5) 				INT_CLK
;06 IRC Frequency select        0
;----------------------------------
;File Note:
;Name TM57ML40_lcd_disp.asm 
;check sum:21B5H 
;Date:2010/11/9
;----------------------------------
;Program Note:
; Shielding the (goto led_set)
; Program will execute lcd scan,
; Otherwise, the execute of led scan
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

#include "TM57ML40_en.inc" 
#include	"maico.asm"
	
		org		000h	  
		goto	start 

;-----------------------------------
		org		10h	 
start: 								;pwm Initialization  
        movlw	11111111b
		movwr	LCDCTRL             
									;BIT(7~6)
									;LCD current control VDD=3V
									;11 => 29.0uA
									;10 => 14.9uA
									;01 => 7.5uA
									;00 => 6uA
									
									;bit(5~3) LCD/LED Duty
									;000: Static
									;001: 1/2 duty
									;010: 1/3 duty
									;011: 1/4 duty
									;100: 1/5 duty
									;101: 1/6 duty
									;110: 1/7 duty
									;111: 1/8 duty 
									  
									;bit2 LCD Bias 0: 1/2 Bias 1: 1/3 Bias					
									;bit(1-0);LCD Brightness;00: Most darkness;11: Most brightness

        movlw	00011101b
	    movwr	TM2CTRL      		;bit4 0: Timer2 Clock is Slow Clock; 1: Timer2 Clock is CPUCLK/128
									;bit 0-1 LCDCLKis Timer2 clock divide by
									;00: 128  31.25k
									;01: 64   62.5k
									;10: 32   125k
									;11: 16   500k
		movlw	11111111b
		movwr	LCDPIN1
		movlw	00001111b
		movwr	LCDPIN0 	
		call	off_lcd 	
			
;		goto	led_set				;led and lcd 

		movlw	00000001b
		movwr	LCD_LED 
		
		movlw	1
		movwf	lcd_ram00 
		movlw	2
		movwf	lcd_ram01 
		movlw	3
		movwf	lcd_ram02 
		movlw	4
		movwf	lcd_ram03
		movlw	5
		movwf	lcd_ram04 
		movlw	6
		movwf	lcd_ram05 
		movlw	7
		movwf	lcd_ram06 
		movlw	8
		movwf	lcd_ram07
		movlw	9
		movwf	lcd_ram08 
		movlw	0
		movwf	lcd_ram09 
		goto	lcd_loop
;-----------------------------------		
led_set:
		movlw	00001110b
		movwr	LCD_LED 			;bit3 1:LED display on 0: LED display off
									;bit2 1:LED high active 0: low active
									;bit1 0:Select LCD 1: Select LED
									;bit0 1:LCD Enable 0: Disable
		
		bsf		flag_one,f_san_00
		bcf		flag_one,f_san_01
		bcf		flag_one,f_san_02
		bcf		flag_one,f_san_03 
		movlw	1
		movwf	led_ram00
		movlw	2
		movwf	led_ram01 
		movlw	3
		movwf	led_ram02
		movlw	4
		movwf	led_ram03  
		
	    movlw	00011111b
	    movwr	TM2CTRL           
									;bit 0-1 LCDCLKis Timer2 clock divide by
									;00: 128  31.25k
									;01: 64   62.5k
									;10: 32   125k
									;11: 16   500k 
        movlw	11011111b
		movwr	LCDCTRL             
									
									;bit(5~3) LCD/LED Duty
									;000: Static
									;001: 1/2 duty
									;010: 1/3 duty
									;011: 1/4 duty
									;100: 1/5 duty
									;101: 1/6 duty
									;110: 1/7 duty
									;111: 1/8 duty 						
			
led_loop:		
		call	Delay
       	call 	Delay	
      	call	off_lcd 
 		call	led_scan 
        goto	led_loop
 
lcd_loop:  
		call	Delay
       	call 	Delay
 		call	lcd_scan                          
		goto	lcd_loop  

;----------------------------------- 
;		LCD off and  all light
;----------------------------------- 
off_lcd:
		movlw	00000000b 
		goto	lcd_ram	
light_lcd:
 		movlw	11111111b 
lcd_ram:
        movwr	DS_LCD1
        movwr	DS_LCD2
        movwr	DS_LCD3
        movwr	DS_LCD4
        movwr	DS_LCD5
        movwr	DS_LCD6
        movwr	DS_LCD7
        movwr	DS_LCD8
        movwr	DS_LCD9
        movwr	DS_LCD10
        movwr	DS_LCD11
        movwr	DS_LCD12
       	movwr	DS_LCD13
        movwr	DS_LCD14
        movwr	DS_LCD15
        movwr	DS_LCD16
        movwr	DS_LCD17
        movwr	DS_LCD18
        movwr	DS_LCD19
       	movwr	DS_LCD20
       	movwr	DS_LCD21
       	
        movwr	DS_LCD22
        movwr	DS_LCD23
        movwr	DS_LCD24
        movwr	DS_LCD25
        movwr	DS_LCD26
       	movwr	DS_LCD27
       	movwr	DS_LCD28

        movwr	DS_LCD29
        movwr	DS_LCD30
       	ret  
       	
Delay:
		NOP
		NOP
		nop
		nop
		DECFSZ	delay,1
		goto	Delay
Del_30ms_end:
		ret		       	
       	
       	
;----------------------------------- 
;			ļ
;-----------------------------------        	
#include	scan_lcd.asm 
#include	scan_led.asm
       	
     	end