;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;		Program	Config
;01.Code protection selection:	Not Protect 
;02.LV reset mode: 				LVR disable
;03.Fast Clock source selection:Fast Crystal 
;04.WDT reset enable			Disable WDT Reset  
;05.EV option(5) 				INT_CLK
;06 IRC Frequency select        0
;----------------------------------
;File Note:
;Name TM57ML40_PWM0.asm 
;check sum:1FADH 
;Date 2010/11/9
;----------------------------------
;Program Note:
;1/(Fosc/Pre divisor* PWM0PRD=pwm cycle
;pwm cycle/PWM0PRD * PWM0_DUTY=pwm duty
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

#include "TM57ML40_en.inc"
	
		org		000h	  
		goto	start
		
		org		004h
		goto	pwm0_int

;----------------------------------- 
		org		10h	 
start: 								;pwm Initialization
		movlw   00100000b
		movwr	CLKCTRL	 			;Auto Save W register and STATUS register when interrupt, 

		movlw	11111111b
		movwr	PAE	              	;PA6=1 is output
		
        movlw	100
        movwf	PWM0_DUTY			;PWM0 duty set  
        
        movlw	200
        movwr	PWM0PRD				;pwm0 cycle
         
        movlw	00001100b 
        movwr	TM1_PWM0_PSC	  	;bit4 PWM0N=0  PWM0 output to PA6 pin
        						
        							;bit(3~2),PWM0 Pre-Scale,
        							;00: Fosc
									;01: Fosc/2
									;10: Fosc/4
									;11: Fosc/8
	
		movlw	11111111b
		movwr	WKTPSC		        ;bit3 PWM0E=1
							  
        bcf		TM_CTRL,CLRPWM0     ;PWM0 hold      
		bsf		INTE1,PWM0IE		;Enable pwm0 int  
  
main:  
        clrwdt
		nop 

		goto	main  
;----------------------------------- 
;			interrput
;----------------------------------- 
pwm0_int:
		bcf		INTF1,PWM0I

pwm0_int_end:
		reti
				                
        end