;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;		Program	Config
;01.Code protection selection:	Not Protect 
;02.LV reset mode: 				LVR disable
;03.Fast Clock source selection:Fast Crystal 
;04.WDT reset enable			Disable WDT Reset  
;05.EV option(5) 				INT_CLK
;06 IRC Frequency select        0
;----------------------------------
;File Note:
;Name TM57ML40_timer1.asm 
;check sum:H 
;Date 2010/9/15
;----------------------------------
;Program Note:
;TM1PSC=1 1/Fosc*(TM1h,TM1L=time
;TM1PSC=0 1/(Fosc/2)*(TM1h,TM1L=time
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

#include "TM57ML40_en.inc"
;---------------------------------
;			bit filp
;--------------------------------- 
negb_	macro	f_flag,ll
		btfss	f_flag,ll
		goto    $+3
		bcf		f_flag,ll
		goto	$+2	 
		bsf		f_flag,ll 
		endm 
;-----------------------------------				
		org		00h	  
		goto	start
		
		org		02h
		goto	timer1_int 
		org		03h
		goto	timer0_int

		NOP
		NOP
		NOP
		NOP

		org		08h
		goto	rfc_int
 
		org		10h	 
start: 								;pwm Initialization 
		movlw   00000000B
		movwf 	INTF1
		
		movlw   00000000B
		movwf	INTE1
		

		movlw	01010001b
		movwr	RFCCON				;bit6 Timer0 overflow to control RFC
									;bit4 select CX0 as RFC Counter CLK
									;bit0 select RFC0 pin for RFC loop
		movlw   00100000b
		movwr	CLKCTRL	 			;Auto Save W register and STATUS register when interrupt, 

     
     	movlw	100
		movwf	TIMER0				;Timer 0 data 
		
		movlw	100
		movwr	TM0RELOAD			;Time0 Reload Data
		
		movlw	11111111b
		movwr	PAE	              	;is output
		movlw	11111111b
		movwr	PEE	              	;is output
	
		movlw	00000000b
        movwf	TM1L 
        
        movlw	00h
        movwf	TM1H   
        
        movlw	00000100b
		movwf	TM_CTRL 
        
        movlw	00001101b
        movwr	TM1_PWM0_PSC 		;bit0 Timer1 Clock Select,1: Fosc,0: Instruction cycle (Fosc/2)
   
		bsf		INTE1,TM1IE			;Enable timer1 int
		bsf		INTE1,TM0IE
		
		bsf		INTE2,RFCINTE  		;RFC Interrupt Enable.
		bcf		TM_CTRL,CLRRFC
		bcf		TM_CTRL,RFCSTOP 	;Stop RFC Counter/Loop 
		
		movlw	00000111b
		movwr	OPTION
      	
      	movlw	0x20
		movwf	FSR	
main:  

       	nop
		nop 

		goto	main  
;----------------------------------- 
;			interrput
;----------------------------------- 
timer1_int:
		bcf		INTF1,TM1I 
		bsf		TM_CTRL,RFCSTOP		
;		negb_	PAD,1   
		goto	int_end
rfc_int:
		bcf		INTF2,RFCINTF 
		goto	int_end
timer0_int:
		bcf		INTF1,TM0I
		;timer1 ouput teset 

		
;		movfw	RFCNTL
;		movwf	INDF
;		incf	FSR,1
;		movfw	FSR
;		xorlw	0x5f
;		btfss	STAT,2
;		goto	LK
;		nop
;		nop 
LK:		
;		movlw	00010001b
;		movwr	RFCCON				;bit6 Timer0 overflow to control RFC
									;bit4 select CX0 as RFC Counter CLK
									;bit0 select RFC0 pin for RFC loop
		nop							 
;		bsf		TM_CTRL,CLRRFC 
;		bcf		TM_CTRL,CLRRFC
		NOP
		NOP
;		bcf		TM_CTRL,CLRRFC   
		
;		movlw	10010001b
;		movwr	RFCCON				;bit6 Timer0 overflow to control RFC
									;bit4 select CX0 as RFC Counter CLK
									;bit0 select RFC0 pin for RFC loop
 		
int_end:
		reti
				                
        end