;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;		Program	Config
;01.Code protection selection:	Not Protect 
;02.LV reset mode: 				LVR disable
;03.Fast Clock source selection:Fast Crystal 
;04.WDT reset enable			Disable WDT Reset  
;05.EV option(5) 				INT_CLK
;06 IRC Frequency select        0
;----------------------------------
;File Note:
;Name TM57ML40_timer0.asm 
;check sum:2B0CH 
;Date: 2010/11/9
;----------------------------------
;Program Note:
;fosc/2/Timer0 Pre-Scale * (256-TIMER0)=time
;or
;TKRC/Timer0 Pre-Scale * (256-TIMER0)=time
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

#include "TM57ML40_en.inc"
;---------------------------------
;			bit filp
;--------------------------------- 
negb_	macro	f_flag,ll
		btfss	f_flag,ll
		goto    $+3
		bcf		f_flag,ll
		goto	$+2	 
		bsf		f_flag,ll 
		endm 
;----------------------------------			
		org		00h	  
		goto	start
        org		03h 
        goto	time0_int
        
		org		10h	 
start: 								;pwm Initialization
		movlw   00100000b
		movwr	CLKCTRL	 			;Auto Save W register and STATUS register when interrupt, 

		movlw	00000000b
		movfw	INTE1
		                           
		movlw	00000000b
		movfw	INTF1  
		
		movlw	11111111b
		movwr	PAE	              	;is output
		
		movlw	156
		movwf	TIMER0				;Timer 0 data 
		
		movlw	156
		movwr	TM0RELOAD			;Time0 Reload Data
		
		movlw	00000001b
		movwr	OPTION   			
									;bit4=1 T0CKI/TKRC bit4=0 Instruction Cycle
									;BIT 3~0	Timer0 Pre-Scale
									;0000: div1
									;0001: div2
									;0010: div4
									;0011: div8
									;0100: div16
									;0101: div32
									;0110: div64
									;0111: div128
									;1xxx: div256
		movlw	11111111b
		movwr	PAE	              	;PD1=1 is output  
		

		bcf		TM_CTRL,STOPTM0 	;;Stop Timer0 when this bit is "1"
        bsf		INTE1,TM0IE         ;enable timer0
main:  
		nop
		nop 

		goto	main  
;----------------------------------- 
;			interrput
;-----------------------------------  
time0_int:
  		bcf		INTF1,TM0IE 
		negb_	PAD,1  				;timer0 ouput teset


		reti
				                
        end