;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;		Program	Config
;01.Code protection selection:	Not Protect 
;02.LV reset mode: 				LVR disable
;03.Fast Clock source selection:Fast Crystal 
;04.WDT reset enable			Disable WDT Reset  
;05.EV option(5) 				INT_CLK
;06 IRC Frequency select        0
;----------------------------------
;File Note:
;Name TM57ML40_timer1.asm 
;check sum:16C2H 
;Date 2010/10/9
;----------------------------------
;Program Note:
;TM1PSC=1 1/Fosc*(65536-TM1h,TM1L=time
;TM1PSC=0 1/(Fosc/2)*(65536-TM1h,TM1L=time
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

#include "TM57ML40_en.inc"
;---------------------------------
;			bit filp
;--------------------------------- 
negb_	macro	f_flag,ll
		btfss	f_flag,ll
		goto    $+3
		bcf		f_flag,ll
		goto	$+2	 
		bsf		f_flag,ll 
		endm 
;-----------------------------------				
		org		00h	  

		goto	start
		
		org		02h
		goto	timer1_int 
 
		org		10h	 
start: 								;pwm Initialization 
		movlw   00000000B
		movwf 	INTF1
		
		movlw   00000000B
		movwf	INTE1
		
		movlw   00100000b
		movwr	CLKCTRL	 			;Auto Save W register and STATUS register when interrupt, 

		movlw	11111111b
		movwr	PAE	              	;is output
		
		movlw	156
        movwf	TM1L 
        
        movlw	255
        movwf	TM1H   
           
        movlw	00000001b
        movwr	TM1_PWM0_PSC 		;bit0 Timer1 Clock Select,1: Fosc,0: Instruction cycle (Fosc/2)
   
   		bcf		TM_CTRL,STOPTM1		;Stop Timer1 when this bit is "1"
		bsf		INTE1,TM1IE			;Enable timer1 int  

main:  
       	nop
		nop 

		goto	main  
;----------------------------------- 
;			interrput
;----------------------------------- 
timer1_int:
		bcf		INTF1,TM1I 
		negb_	PAD,1  				;timer1 ouput teset

timer1_int_end:
		reti
				                
        end