;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;		Program	Config
;01.Code protection selection:	Not Protect 
;02.LV reset mode: 				LVR disable
;03.Fast Clock source selection:Fast Crystal 
;04.WDT reset enable			Disable WDT Reset  
;05.EV option(5) 				INT_CLK
;06 IRC Frequency select        0
;----------------------------------
;File Note:
;Name TM57ML40_timer2.asm 
;check sum:3CA6H 
;Date 2010/10/9
;----------------------------------
;Program Note:
;TIMER2CLK=1 1/slow clock*clock divide	=time
;TIMER2CLK=0 1/(fosc/128)*clock divide	=time
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

#include "TM57ML40_en.inc"
;---------------------------------
;			bit filp
;--------------------------------- 
negb_	macro	f_flag,ll
		btfss	f_flag,ll
		goto    $+3
		bcf		f_flag,ll
		goto	$+2	 
		bsf		f_flag,ll 
		endm 
				
		org		00h	  
		goto	start
		
		org		01h
		goto	timer2_int
;----------------------------------- 
		org		10h	 
start: 								;pwm Initialization 
		movlw   00000000B
		movwf 	INTF1
		
		movlw   00000000B
		movwf	INTE1
		
		movlw   00100000b
		movwr	CLKCTRL	 			;Auto Save W register and STATUS register when interrupt, 
       
       	movlw	11111111b
       	movwr	PAE

       	movlw	00011100b
       	movwr	TM2CTRL             ;BIT4 timer2 clock 0:Slow Clock 1:Fosc/128
       								;BIT3~2 W 0 Timer2 clock divide by
									;00: 32768
									;01: 16384
									;10: 8192
									;11: 128 

		 
		bcf		TM_CTRL,CLRTM2		;Timer2 clear and hold when this bit is "1"			
		bsf		INTE1,TM2IE			;Enable timer1 int  

        
main:  
       	nop
		nop 

		goto	main  
;----------------------------------- 
;			interrput
;----------------------------------- 
timer2_int:
		bcf		INTF1,TM2I 
		negb_	PAD,1     			;TIMER2 output teset

timer1_int_end:
		reti
				                
        end