;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;		Program	Config
;01.Code protection selection:	Not Protect 
;02.LV reset mode: 				LVR disable
;03.Fast Clock source selection:Fast Crystal 
;04.WDT reset enable			Disable WDT Reset  
;05.EV option(5) 				INT_CLK
;06 IRC Frequency select        0
;----------------------------------
;File Note:
;Name TM57ML40_touch_key.asm 
;check sum:0535H 
;Date 2010/10/9
;----------------------------------
;Program Note:
;1/(Fosc/Pre divisor*256=pwm cycle
;pwm cycle/256*PWM0_DUTY=pwm duty
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;---------------------------------
;			bit filp
;--------------------------------- 
negb_	macro	f_flag,ll
		btfss	f_flag,ll
		goto    $+3
		bcf		f_flag,ll
		goto	$+2	 
		bsf		f_flag,ll 
		endm 
		
#include "TM57ML40_en.inc" 
	
		org		000h	  
		goto	start 
		
		org		02h
		goto	timer1_int 
				
        org		03h 
        goto	time0_int
;-----------------------------------
		org		10h	 
start: 
		movlw   00100000b
		movwr	CLKCTRL	 			;Auto Save W register and STATUS register when interrupt, 
	
		movlw	01000000b
		movwr	TKCTRL			;bit6=1 Timer0 Source is Touch Key 
								;BIT(5~4) W 0
								;Touch Key Oscillation Frequency Select
								;00: Fastest Touch Key clock
								;11: Slowest Touch Key clock
								;bit(0-3)Touch Key Channel Select
								;0000: TK0
								;0001: TK1
								;
								;1110: TK14
								;1111: NO channel
							
		movlw	00110000b 
		movwr	OPTION			;bit5 1: T0CKI/TKRC falling edge 0: T0CKI/TKRC rising edge for Timer0 Prescaler count
								;bit4=1 T0CKI/TKRC as Timer0 Prescaler clock;
								;BIT 3~0	Timer0 Pre-Scale
								
;		bsf		TM_CTRL,STOPTM0 ;Stop Timer0 when this bit is "1"
		
		clrf	TIMER0 					

		bsf		TM_CTRL,STOPTM1 ;Stop Timer1 when this bit is "1"
		
        movlw	11111111b
        movwf	PBD
        
		movlw	00000000b
		movwr	PBE
		
		movlw	11111111b
		movwr	PB_PULL 
		movwr	PAE
		
		bcf		TM_CTRL,STOPTM0 	;;Stop Timer0 when this bit is "1"
        bsf		INTE1,TM0IE         ;enable timer0

		movlw	00
        movwf	TM1L 
        
        movlw	00
        movwf	TM1H   
           
        movlw	00000001b
        movwr	TM1_PWM0_PSC 		;bit0 Timer1 Clock Select,1: Fosc,0: Instruction cycle (Fosc/2)
   
   		bcf		TM_CTRL,STOPTM1		;Stop Timer1 when this bit is "1"
		bsf		INTE1,TM1IE			;Enable timer1 int  
;-----------------------------------	
		movlw	0x20
		movwf	FSR		
main:
		nop
		nop
		nop
		goto	main

;----------------------------------- 
;			interrput
;-----------------------------------  
time0_int:
  		bcf		INTF1,TM0IE 
;		negb_	PAD,1  				;timer0 ouput teset


		reti
;----------------------------------- 
;			interrput
;----------------------------------- 
timer1_int:
	 	bcf		INTF1,TM1I 
;		negb_	PAD,1  				;timer1 ouput teset 

		movfw	TIMER0  
		movwf	INDF
		incf	FSR,1
		movfw	FSR
		xorlw	0x7f
		btfss	STAT,2
		goto	timer1_int_end
		movlw	0x20
		movwf	FSR	    
timer1_int_end:
        clrf	TIMER0 
		reti
;----------------------------------- 
;			ļ
;-----------------------------------        	
;#include	scan_lcd.asm 

     	end