;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;		Program	Config
;01.Code protection selection:	Not Protect 
;02.LV reset mode: 				LVR disable
;03.Fast Clock source selection:Fast Crystal 
;04.WDT reset enable			Disable WDT Reset  
;05.EV option(5) 				INT_CLK
;06 IRC Frequency select        0
;----------------------------------
;File Note:
;Name TM57ML40_wakeup.asm 
;check sum:0535H 
;Date 2010/11/9/
;----------------------------------
;Program Note:
;
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

#include "TM57ML40_en.inc"
	
		org		00h	  
		goto	start
		
		org		01h
		goto	timer2_init
		org		05h
		goto	wkt_init
		org		06h
		goto	xinta_int  			;exit interrpt PA0 PA1 PB0
		org		07h
		goto	xintb_int        	;exit interrup	PB1
		org		08h
		goto	rfc_in
;----------------------------------- 
		org		10h	 
start: 								;pwm Initialization
		movlw	11111111b
		movwr	PAE	              	;PA6=1 is output

       	movlw	00001100b
       	movwr	TM2CTRL             ;BIT4 timer2 clock 0:Slow Clock 1:Fosc/128
       								;BIT3~2 W 0 Timer2 clock divide by
									;00: 32768
									;01: 16384
									;10: 8192
									;11: 128 
		movlw	00000000b
		movwf	TM_CTRL 
							
		bsf		INTE1,TM2IE			;Enable timer1 int  
;------------------------------------ 
		movlw	11111111b
		movwf	PAD
		movlw	00000000b
		movwr	PAE
		movwr	PA_PULL
		
		movlw	11111111b
		movwf	PBD
		movlw	00000000b
		movwr	PBE
		movwr	PB_PULL
		
		bsf		INTE1,XINT0E
		bsf		INTE1,XINT1E 
		bsf		INTE1,XINT2E  		;open exit interrupt
		
		bsf		INTE2,XINT3E
		bsf		INTE1,WKTIE 
 		bcf		flag_one,f_idle_stop
;------------------------------------  
	
    	btfss	flag_one,f_idle_stop 
    	goto	stop_mode	
;----------------------------------
;       IDLE Mode SLEEP
;---------------------------------- 
idle_mode:     
        movlw   00100101b          	;ѡڲʱ	
		movwr	CLKCTRL	            									;bit6:Enable high gain to kick SXT
									;bit5:Auto Save W register and STATUS register when interrupt, and restore them
									;when exit from interrupt
									;bit4:select Slow Clock as cpu clk
									;bit3stop Fast Clock
									;bit4Slow Clock enable
									;BIT(1~0) W 0 Slow clock type 0:SXT; 1:SIRC; 2:XRC, 3:TKCLK
       	goto	sleep_loop
stop_mode: 
        movlw   00100000b          	;ѡڲʱ	
		movwr	CLKCTRL	 
sleep_loop:
 		sleep	
        nop  
                
		goto	sleep_loop  
;----------------------------------- 
;			interrput
;-----------------------------------
timer2_init:
		bcf		INTF1,TM2I 

  		goto	int_end
wkt_init:
       	btfsc	INTF1,WKTI 
		goto	int_end
xintb_int:		
        bcf		INTF2,XINT3
		goto	int_end
xinta_int:						
		btfsc	INTF1,XINT0
		goto	it_pa0
		btfsc	INTF1,XINT1
		goto	it_pa1
		btfsc	INTF1,XINT2
		goto	it_pb0
		goto	int_end
it_pa0:
		bcf		INTF1,XINT0
		goto	int_end
it_pa1:
		bcf		INTF1,XINT1
		goto	int_end
it_pb0:		
		bcf		INTF1,XINT2
       	goto	int_end
rfc_in:

        goto	int_end
int_end:
		reti
				                
        end